Program DBF2TXT;
{dBase to Text file transformation}
uses DBF1Plus,Crt;
const
  Tab = #9;
  Sp  = ' ';
  NL  = #10#13;
var
  Info,Prompt : boolean;

  No,Ni: string;
  DBF : TDbase;
  fo  : text;
  i,j : integer;
  fbuf: TField;
  Reply: Char;
  Delimiter : string;

Procedure WritePrompt(Current,Full:word);
var
  X,Y : byte;
begin
  X := WhereX;
  Y := WhereY;
  write((Current/Full)*100:5:0,'%');
  GotoXY(X,Y);
end;
begin
  Writeln('DBF2TXT, dBase to text transformation utility, 911Soft, 1994-95');
  case ParamCount of
  2: begin
       Ni := ParamStr(1);
       No := ParamStr(2);
       Info :=false;
       Prompt := false;
     end;
  3: begin
       Ni := ParamStr(1);
       No := ParamStr(2);
       Info := (ParamStr(3) = '/I') or (ParamStr(3) = '/i');
       Prompt := (ParamStr(3) = '/P') or (ParamStr(3) = '/p');
     end;
  4: begin
       Ni := ParamStr(1);
       No := ParamStr(2);
       Info := (ParamStr(3) = '/I') or (ParamStr(3) = '/i')
            or (ParamStr(4) = '/I') or (ParamStr(4) = '/i');
       Prompt := (ParamStr(3) = '/P') or (ParamStr(3) = '/p')
              or (ParamStr(4) = '/P') or (ParamStr(4) = '/p');
     end;
  else
    begin
      Writeln('Usage: dbf2txt dbfname txtname [/I] [/P]');
      Writeln('where: dbfname - source dBase file');
      Writeln('       txtname - result Text file');
      Writeln('            /I - put information about header in text');
      Writeln('            /P - prompt delimiter sequence (default Tab #09)');
      Halt(1);
    end;
  end;
  DBF.Init(NI);
  DBF.Error;
  if Prompt then
    begin
      Write('Dalimiters: '); readln(Delimiter);
      Writeln(DBF.RecNo,' record(s) detected.');
    end
  else Delimiter := Tab;
  assign(fo,no);
  {$I-}
  rewrite(fo);
  {$I+}
  if IOResult <> 0 then
    begin
      Writeln(' - error: unable to open output file');
      Halt;
    end;
  if Info then
  begin
     writeln(fo,'[header]');
     case DBF.Version of
       1: writeln(fo,'version=dBASE I');
       2: writeln(fo,'version=dBASE II');
       3: writeln(fo,'version=dBASE III');
       4: writeln(fo,'version=dBASE IV');
       else
         writeln(fo,'version=Unknown, (',DBF.Version,')');
     end;
     writeln(fo,'date=',DBF.LastDate.DD,'/',DBF.LastDate.MM,'/',DBF.LastDate.YY);
     writeln(fo,'[records]');
     writeln(fo,'count=',DBF.RecNo);
     writeln(fo,'length=',DBF.RecLen);
     writeln(fo,'[fields]');
     writeln(fo,'count=',DBF.FieldNo);
     writeln(fo,'FIELD':6,TAB,'NAME':12,TAB,'TYPE':5,TAB,'LEN':5);
     for i:=1 to DBF.FieldNo do
       begin
         DBF.GetField(i,fbuf);
         writeln(fo,'field',i,TAB,fbuf.N:12,TAB,fbuf.T:5,TAB,fbuf.L:5,TAB);
       end;
  end;
  if Info then writeln(fo,'[begin]');
  write('Processing:');
  WritePrompt(0,100);
  for i:=1 to DBF.RecNo do
    begin
      for j:=1 to DBF.FieldNo-1 do
        write(fo,DBF.GetCell(i,j),Delimiter);
      writeln(fo,DBF.GetCell(i,j+1));
      if i mod (DBF.RecNo div 20) = 0 then WritePrompt(i,DBF.RecNo);
    end;
  WritePrompt(100,100);
  delay(300);  
  if Info then writeln(fo,'[end]');
  close(fo);
  DBF.Done;
  Delline;
  writeln;
  writeln('Done.');
end.
